---------------------------------------------------------------------------------------
---							HeroicDefense by Bot_romka v 0.3						---
---------------------------------------------------------------------------------------

local HD_version = "v 0.3";
local InGameFrame;
local HD_Activ = false;
local HD_TimerStart = 0;
local HeroicDefense = {};
local PlaceHDmacro = false;
local DailyQuestInfo = false;
local AutoPlaceHDmacro = true;
local HD_Message = "Lurker";	-- Set message for auto invite
local ActionbarSlot = 1;		-- Set number of actionbar slot for HD Macro
local HD_LoginNextToon = true;	-- Set to false or true for use LoginNextToon after complete all daily quests.

-- OnLoad
function HeroicDefense_OnLoad(this)
	InGameFrame = this
	this:RegisterEvent("LOADING_END")
	this:RegisterEvent("ZONE_CHANGED")
	HD_TimerStart = GetTickCount()
	--this:RegisterEvent("QUEST_COMPLETE")
	DEFAULT_CHAT_FRAME:AddMessage("Addon HeroicDefense "..HD_version.." loaded.")
end;

-- OnEvent
function HeroicDefense_OnEvent(this, event, arg1, arg2, arg3, arg4)
	if( event == "LOADING_END" and GetZoneID() == 13 ) then
		--DEFAULT_CHAT_FRAME:AddMessage("HeroicDefense_OnEvent 1");
		PlaceHDmacro = true
		HD_Activ = true
		if( declineInvite_conf ) then
			declineInvite_conf["ENABLED"] = false
		end
	elseif( event == "ZONE_CHANGED" and arg2 == 13 ) then
		--SendSystemChat("AutoToggle:"..arg1.." ZoneID:"..arg2)
		PlaceHDmacro = true
		HD_Activ = true
		if( declineInvite_conf ) then
			declineInvite_conf["ENABLED"] = false
		end
	--elseif( event == "QUEST_COMPLETE" ) then
		--SendSystemChat("QUEST_COMPLETE arg1:"..arg1..", arg2: "..(arg2 or 0)..", arg3: "..(arg3 or 0)..", arg4: "..(arg4 or 0))
	end
end;

-- OnUpdate
function HeroicDefense_OnUpdate()
	local HD_Timer = GetTickCount() - HD_TimerStart
	if( DailyQuestInfo and HD_Timer > 1000 ) then
		local DailyQuestCount = Daily_count()
		local PhiriusCount = GetBagItemCount(203038)
		DEFAULT_CHAT_FRAME:AddMessage("HD. ".. string.format(TEXT("ITEMMALL_TEXT_5"), DailyQuestCount) .." ".. TEXT("Q_GROUPNAME_02") ..", |cff008888".. PhiriusCount .."|r ".. TEXT("Sys203038_name"))
		DailyQuestInfo = false
--		if( HD_LoginNextToon and DailyQuestCount == 10 and 420 > PhiriusCount ) then
		if( HD_LoginNextToon and DailyQuestCount == 10 ) then
			LoginNextToon = true
			Logout()
		end
	end
	if( PlaceHDmacro and HD_Timer > 1500 ) then
		DEFAULT_CHAT_FRAME:AddMessage("PlaceHDmacro");
		HD_FindEditMacro()
		PlaceHDmacro = false
		if( GetZoneID() == 13 ) then
			SendChatMessage(HD_Message,"ZONE",0);
		end
	end
end;

-- SpeakFrame function
HeroicDefense.orig_SpeakFrame_LoadQuest = SpeakFrame_LoadQuest
function SpeakFrame_LoadQuest()
    HeroicDefense.orig_SpeakFrame_LoadQuest()
	if HD_Activ == false then return end
	for i = 1, g_SpeakFrameData.count do
		if g_SpeakFrameData.option[i].type == DF_IconType_FinishedQuest then
			OnClick_QuestListButton(3, 1)
			HD_TimerStart = GetTickCount()
			DailyQuestInfo = true
			CompleteQuest()
			SpeakFrame_Hide()
		elseif g_SpeakFrameData.option[i].type == DF_IconType_NewQuest then
			OnClick_QuestListButton(1, 1)
			AcceptQuest()
			SpeakFrame_Hide()
		end
	end
end;

---------------------------------------------------------------------------------------------
-- Local references to API for faster access
local UseSkill = UseSkill
local OBB_ChangeTraget = OBB_ChangeTraget
local PickupMacroItem = PickupMacroItem
local PickupAction = PickupAction

-- Get quest status in Quest Book by Quest Id
function HD_GetQuestStatus(_questid)
	local _questid = _questid or 423931				-- Quest Id or daily quest Heroic Defense
	for i = 1, GetNumQuestBookButton_QuestBook() do	-- Number total quests in Quest Book
		local matched
		local getid = GetQuestId(i)					-- ID of a Quest
		local matched = (_questid == getid)
		if matched then								-- Quest exists
			for k = 1, GetQuestRequest(i,-1) do		-- for each goal
				local __, getstatus = GetQuestRequest(i,k)
				if getstatus == 0 then				-- check if not complete
					return "incomplete"
				end
			end
			return "complete"
        end
	end
	return "not accepted"
end;

-- Find HD Macro or free slot for edit HD Macro.	/run HD_FindEditMacro();
--local function HD_FindEditMacro()
function HD_FindEditMacro()
	for i = 1, 48 do
		local icnum,name,body=GetMacroInfo(i)
		if name == "HD_NPC" and body == "/run HD_NPC();" then
			local icon_path,slotname=GetActionInfo(ActionbarSlot);
			if (IsShiftKeyDown() or AutoPlaceHDmacro) and slotname ~= "HD_NPC" then		-- place HD macro to Actionbar slot 1
				PickupMacroItem(i)
				PickupAction(ActionbarSlot)
				PickupAction(21)
			end
			return
		end
	end
	for i = 1, 48 do
		if not HasMacro(i) then
			EditMacro(i, "HD_NPC", 5, "/run HD_NPC();")
			local icon_path,slotname=GetActionInfo(ActionbarSlot);
			if (IsShiftKeyDown() or AutoPlaceHDmacro) and slotname ~= "HD_NPC" then		-- place HD macro to Actionbar slot 1
				PickupMacroItem(i)
				PickupAction(ActionbarSlot)
				PickupAction(21)
			end
			return
		end
	end
	SendWarningMsg("Error! Not find free slot for edit HD Macro.")
end;

-- NPC GUID. Atenttion its different for each server and chennal.
-- Macro: /run i=UnitGUID("target") + GetZoneID()*65536; DEFAULT_CHAT_FRAME:AddMessage("Target GUID: "..i);

local Beeder_GUID = 852930						-- Chennal I

-- Target daily quest NPC.		/run HD_NPC();
function HD_NPC()
	local QuestStatus = HD_GetQuestStatus()
	if QuestStatus == "not accepted" or QuestStatus == "complete" then
		OBB_ChangeTraget(Beeder_GUID)			-- Valiant Beeder
		HD_TimerStart = GetTickCount()
		UseSkill(1,1)
	end
end;

